"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
function matchIndex(text, query, sensitive) {
    if (sensitive) {
        return text.indexOf(query);
    }
    return text.toLowerCase().indexOf(query.toLowerCase());
}
function highlight(text, query, textFactory, highlightFactory, sensitive) {
    if (!query.length || matchIndex(text, query, sensitive) === -1) {
        return textFactory(text);
    }
    var result = [];
    function push(el) {
        result.push(React.cloneElement(el, { key: result.length }));
    }
    var rest = text;
    var index = matchIndex(rest, query, sensitive);
    while (index !== -1) {
        if (index !== 0) {
            push(textFactory(rest.substr(0, index)));
        }
        push(highlightFactory(rest.substr(index, query.length)));
        rest = rest.substr(index + query.length);
        index = matchIndex(rest, query, sensitive);
    }
    if (rest.length) {
        push(textFactory(rest));
    }
    return result;
}
exports.highlight = highlight;
//# sourceMappingURL=highlight.js.map